/***********************************************************
* Kuvaus: Tyttmyysturvan lainsdnt makroina          *
***********************************************************/ 

/* 1. SISLLYS */

/* Tiedosto sislt seuraavat makrot */

/*
2. AnsioSidKS = Ansiosidonnainen pivraha kuukausitasolla
3. AnsioSidVS = Ansiosidonnainen pivraha kuukausitasolla vuosikeskiarvona
4. TyomTukiKS = Tymarkkinatuki kuukausitasolla
5. TyomTukiVS = Tymarkkinatuki kuukausitasolla vuosikeskiarvona
6. PerusPRahaKS =  Peruspivraha kuukausitasolla
7. PerusPRahaVS = Peruspivraha kuukausitasolla vuosikeskiarvona
8. SoviteltuKS = Soviteltu tyttmyyspivraha kuukausitasolla
9. SoviteltuVS = Soviteltu tyttmyyspivraha kuukausitasolla vuosikeskiarvona   
10. AnsioSidPalkkaS = Ansiosidonnaisen pivrahan perusteena oleva palkka kuukausitasolla
11. AnsioSidPalkkaVanhaS = Ansiosidonnaisen pivrahan perusteena oleva palkka kuukausitasolla (makro aineiston laskennallisten muuttujien pttelyyn)
12. YPitoKorvS = Yllpitokorvaukset kuukausitasolla
13. YPitoKorvVS = Yllpitokorvaukset kuukausitasolla vuosikeskiarvona    
14. VuorVapKorvKS = Vuorotteluvapaakorvaukset kuukausitasolla
15. VuorVapKorvVS = Vuorotteluvapaakorvaukset kuukausitasolla vuosikeskiarvona     
16. SovPalkkaS = Sovitellun pivrahan perusteena oleva palkka kuukausitasolla
17. TarvHarkTuloS = Tymarkkinatuen tarveharkinnan perusteena oleva tulo kuukausitasolla
18. OsittTmTTuloS = Osittaisen tymarkkinatuen perusteena oleva vanhempien tulo kuukausitasolla
19. AnsioSidKestoRaj = Ansiopivrahan ja vuorottelukorvauksen enimmis- ja vhimmiskeston rajaus
*/ 


/*  2. Makro laskee ansiosidonnaisen tyttmyyspivrahan kuukausitasolla */

*Makron parametrit:
	tulos: Makron tulosmuuttuja, ansiosidonnainen tyttmyyspivraha, e/kk 
	mvuosi: Vuosi, jonka lainsdnt kytetn
	mkuuk: Kuukausi, jonka lainsdnt kytetn 
	minf: Deflaattori euromristen parametrien kertomiseksi 
  	lapsia: Lapsien lkm perheess 
	oikeuskor: Onko oikeus korotettuun pivrahaan
	muutturva: Onko oikeus muutosturvaan
	lisapaiv: onko oikeus lispiviin (0/1)
	kuukpalkka: Tyttmyytt edeltv kuukausipalkka
	vahsosetuus: Pivrahasta vhennettv muu sosiaalietuus, e/kk
	maxtklaskr: Ansiopivrahapivien korkein lukumr aineistovuodelta
	edtklaskr: Ansiopivrahapivien lukumr edellisen vuoden viimeiselt kvartaalilta
	aktiivi: Aktiivimallin leikkuri;
	
%MACRO AnsioSidKS(tulos, mvuosi, mkuuk, minf, lapsia, oikeuskor, muutturva, lisapaiv, kuukpalkka, vahsosetuus, maxtklaskr, edtklaskr, aktiivi=0)/ 
DES = 'TTURVA: Ansiosidonnainen pivraha kuukausitasolla';

%HaeParam&TYYPPI(&mvuosi, &mkuuk, &TTURVA_PARAM, PARAM.&PTTURVA);
%ParamInf&TYYPPI(&mvuosi, &mkuuk, &TTURVA_MUUNNOS, &minf);

%LuoKuuID(kuuid, &mvuosi, &mkuuk);

*Lapsikorotukset;
IF &lapsia <= 0 THEN lapsikor = 0;
ELSE IF &lapsia < 2 THEN lapsikor = &TTLaps1;
ELSE IF &lapsia < 3 THEN lapsikor = &TTLaps2;
ELSE lapsikor = &TTLaps3;

*Kuukausipalkkaan tehtv vhennys;
tyotulo = (1 - &VahPros) * (&kuukpalkka / &TTPAIVIA);

*Korotetun pivrahan ja tyllistymisohjelmalisn prosentit. Tss on varmistettu ett korotuksia ei tule kun ne eivt ole olleet voimassa;
IF &oikeuskor NE 0 AND &mvuosi >= 2003 THEN DO;
	pros1 = &ProsKor1;
	pros2 = &ProsKor2;
	raja = tyotulo;
END;
ELSE IF &muutturva NE 0 AND kuuid >= MDY(7, 1, 2005) AND &mvuosi <= 2013 THEN DO;
	pros1 = &MuutTurvaPros1;
	pros2 = &MuutTurvaPros2;
	raja = tyotulo;
END;
ELSE IF &lisapaiv NE 0 AND 2003 <= &mvuosi <= 2009 THEN DO; 
	pros1 = &TTPros1;
	pros2 = &ProsKor2;
	raja = &ProsYlaRaja * tyotulo;
END;
ELSE DO;
	pros1 = &TTPros1;
	pros2 = &TTPros2;
	raja = &ProsYlaRaja * tyotulo;
END;

*Ansiosidonnaisen pivrahan varsinainen laskukaava;
IF (1 - &VahPros) * &kuukpalkka < &TTTaite * &TTPerus THEN temp = SUM(&TTPerus, pros1 * SUM(tyotulo, -&TTPerus), lapsikor);
ELSE temp = SUM(&TTPerus, pros1 * SUM(&TTTaite * &TTPerus / &TTPAIVIA, -&TTPerus), pros2 * SUM(tyotulo, -&TTTaite * &TTPerus / &TTPAIVIA), lapsikor);

*Ansiopivrahojen porrastus;
IF &maxtklaskr > 0 THEN DO;

	/* Nollataan edellisen vuoden pivt, jos laskuri on nollaantunut. */
	IF &edtklaskr > &maxtklaskr THEN EdPaivat = 0;
	ELSE EdPaivat = &edtklaskr;

	/* Lasketaan pivt aineistovuoden puolella. Jos erotus on nolla annetaan arvoksi nykyisen vuoden maksimiarvo. */
	IF SUM(&maxtklaskr, -EdPaivat) <= 0 THEN NykPaivat = &maxtklaskr;
	ELSE NykPaivat = SUM(&maxtklaskr, -EdPaivat); 

	/* Lasketaan kertoimet kertyneiden pivien mukaisesti */
	maksimi1 = MAX(0, SUM(&PorrasPv1, -EdPaivat));  				/* Maksimimr pivi ilman leikkausta */
	maksimi2 = MAX(0, SUM(&PorrasPv2, -&PorrasPv1, -MAX(0, SUM(EdPaivat, -&PorrasPv1)))); 	/* Maksimimr pivi ensimmisell portaalla */

	AprLkmNormi = MIN(maksimi1, NykPaivat); 						/* Ei-leikattavien pivien lukumr */
	AprLkm1 = MAX(0, MIN(maksimi2, SUM(NykPaivat, -AprLkmNormi))); 	/* Ensimmisen porrastuksen jlkeisten pivien lukumr */
	AprLkm2 = SUM(NykPaivat, -AprLkmNormi, -AprLkm1); 				/* Toisen porrastuksen jlkeisten pivien lukumr */

	APRKerroin = (APRlkmNormi*1 + APRlkm1*&PorrasKerroin1 + APRlkm2*&PorrasKerroin2) / NykPaivat;
	
	IF APRKerroin > 0 THEN temp = APRKerroin * temp;

END;

*Maksimipivraha;
IF temp > raja THEN temp = raja;

*Minimipivraha;
IF &mvuosi >= 2012 AND (&muutturva NE 0 OR &oikeuskor NE 0) THEN temp = MAX(temp, SUM(&TTPerus, lapsikor, &KorotusOsa));
ELSE temp = MAX(temp, SUM(&TTPerus, lapsikor));

*Aktiivimallin leikkuri;
IF &aktiivi = 1 AND 2018 =< &mvuosi <= 2019 THEN temp = SUM(temp * SUM(1, -&AlePros)); 

temp = SUM(temp * &TTPAIVIA, -&vahsosetuus);
IF temp < 0 THEN temp = 0;

&tulos = temp;
DROP temp kuuid tyotulo raja lapsikor pros1 pros2 EdPaivat NykPaivat maksimi1 maksimi2 AprLkmNormi AprLkm1 AprLkm2 APRKerroin; 
%MEND AnsioSidKS;


/*  3. Makro laskee ansiosidonnaisen tyttmyyspivrahan kuukausitasolla vuosikeskiarvona */

*Makron parametrit:
	tulos: Makron tulosmuuttuja, ansiosidonnainen tyttmyyspivraha, e/kk (vuosikeskiarvo)
	mvuosi: Vuosi, jonka lainsdnt kytetn
	minf: Deflaattori euromristen parametrien kertomiseksi 
  	lapsia: Lapsien lkm perheess 
	oikeuskor: Onko oikeus korotettuun pivrahaan
	lisapaiv: Onko oikeus ansiopivrahojen korotettuihin lispiviin
	muutturva: Onko oikeus tyllistymisohjelmalisn
	kuukpalkka: Tyttmyytt edeltv kuukausipalkka
	vahsosetuus: Pivrahasta vhennettv muu sosiaalietuus, e/kk
	maxtklaskr: Ansiopivrahapivien korkein lukumr aineistovuodelta
	edtklaskr: Ansiopivrahapivien lukumr edellisen vuoden viimeiselt kvartaalilta
	aktiivi: Aktiivimallin leikkuri;

%MACRO AnsioSidVS(tulos, mvuosi, minf, lapsia, oikeuskor, muutturva, lisapaiv, kuukpalkka, vahsosetuus, maxtklaskr, edtklaskr, aktiivi=0)/ 
DES = 'TTURVA: Ansiosidonnainen pivraha kuukausitasolla vuosikeskiarvona';

vuosipraha = 0;

%DO i = 1 %TO 12;
	%AnsioSidKS(temp, &mvuosi, &i, &minf, &lapsia, &oikeuskor, &muutturva, &lisapaiv, &kuukpalkka, &vahsosetuus, &maxtklaskr, &edtklaskr, aktiivi=&aktiivi);
	vuosipraha = SUM(vuosipraha, temp);
%END;

&tulos = vuosipraha / 12;
DROP temp vuosipraha;
%MEND AnsioSidVS;



/*  4. Makro laskee tymarkkinatuen kuukausitasolla */

*Makron parametrit:  
	tulos: Makron tulosmuuttuja, tymarkkinatuki, e/kk 
	mvuosi: Vuosi, jonka lainsdnt kytetn
	mkuuk: Kuukausi, jonka lainsdnt kytetn 
	minf: Deflaattori euromristen parametrien kertomiseksi 
	tarvhark: Onko kyseess tarveharkittu tymarkkinatuki (0/1)
	ositt: Onko kyseess osittainen tymarkkinatuki (0/1)
	puoliso: Onko saajalla puolisoa (0/1)
	lapsia: Lapsien lkm perheess 
	huoll: Muiden huollettavien lkm perheess, jos kyseess osittainen tmtuki
	omatulo: Oman muun tulon mr, e/kk
	puoltulo: Puolison tulon mr, e/kk
	vanhtulot: Vanhempien kuukausitulot, jos kyseess osittainen tmtuki, e/kk
	oikeuskor: Onko oikeus korotusosaan (0/1)
	vahsosetuus: Pivrahasta vhennettv muu sosiaalietuus, e/kk
	aktiivi: Aktiivimallin leikkuri;

%MACRO TyomTukiKS(tulos, mvuosi, mkuuk, minf, tarvhark, ositt, puoliso, lapsia, huoll, omatulo, puoltulo, vanhtulot, oikeuskor, vahsosetuus, aktiivi=0)/
DES = 'TTURVA: Tymarkkinatuki kuukausitasolla';

%HaeParam&TYYPPI(&mvuosi, &mkuuk, &TTURVA_PARAM, PARAM.&PTTURVA);
%ParamInf&TYYPPI(&mvuosi, &mkuuk, &TTURVA_MUUNNOS, &minf);

*Lapsikorotukset;
IF &lapsia <= 0 THEN lapsikor = 0;
ELSE IF &lapsia < 2 THEN lapsikor = &TyomLapsPros * &TTLaps1;
ELSE IF &lapsia < 3 THEN lapsikor = &TyomLapsPros * &TTLaps2;
ELSE lapsikor = &TyomLapsPros * &TTLaps3;

*Tysmrinen tymarkkinatuki;
temp = &TTPAIVIA * SUM(&TTPerus, lapsikor);
IF &oikeuskor NE 0 AND &mvuosi >= 2010 THEN temp = SUM(temp, &TTPAIVIA * &KorotusOsa);

*Tarveharkittu tuki;

IF &tarvhark NE 0 THEN DO;

	*Perheellisen tarveharkinta;
	IF &puoliso NE 0 OR &lapsia > 0 THEN DO;
		raja = SUM(&RajaHuolt, &lapsia * &RajaLaps );

		*Puolison tuloista tehtv vhennys;
		*Vuonna 2013 tyttmyysturvan tarveharkinta puolisojen tulojen perusteella poistui; 
		IF &puoliso NE 0 AND &mvuosi < 2013 THEN DO;
			tulo =  SUM(&puoltulo, -&PuolVah);
			IF tulo < 0 THEN tulo =  0;
		END;

		tulo = SUM(tulo, &omatulo);

		IF tulo > raja THEN temp = SUM(temp, -&TarvPros2 * SUM(tulo, -raja));
	END;

	*Yksinisen tarveharkinta;
	ELSE IF &omatulo > &RajaYks THEN temp = SUM(temp, -&TarvPros1 * SUM(&omatulo -&RajaYks));

	IF temp < 0 THEN temp = 0;
END;

*Osittainen tuki; 
IF &ositt NE 0 THEN DO;

	IF &mvuosi >= 2003 THEN DO;
		raja = SUM(&OsRaja, &huoll * &OsRajaKor);

		*Tietyn rajan jlkeen vanhemman tulot pienentvt osittaista tymarkkinatukea. Tuki on kuitenkin minimissn tietty prosentti tydest tuesta.;
		IF &vanhtulot > raja THEN DO;
			testi = temp;
			temp  = SUM(temp, -&OsTarvPros * SUM(&vanhtulot, -raja));
			IF temp < &OsPros * testi THEN temp = &OsPros * testi;
		END; 

	END;

	*Ennen vuotta 2003 osittainen tyomtukeen ei vaikuttanut vanhempien tulot vaan se oli aina tietty osuus tysmrisest.;
	ELSE temp = &OsPros * temp;
END;

*Aktiivimallin leikkuri;
IF &aktiivi = 1 AND 2018 =< &mvuosi <= 2019 THEN temp = SUM(temp * SUM(1, -&AlePros)); 
	
temp = temp - &vahsosetuus;
IF temp < 0 THEN temp = 0;
IF &mvuosi < 1994 THEN temp = .;

&tulos = temp;
DROP raja testi temp tulo lapsikor;
%MEND TyomTukiKS;


/*  5. Makro laskee tymarkkinatuen kuukausitasolla vuosikeskiarvona */

*Makron parametrit:  
	tulos: Makron tulosmuuttuja, tymarkkinatuki, e/kk (vuosikeskiarvo)
	mvuosi: Vuosi, jonka lainsdnt kytetn
	minf: Deflaattori euromristen parametrien kertomiseksi 
	tarvhark: Onko kyseess tarveharkittu tymarkkinatuki (0/1)
	ositt: Onko kyseess osittainen tymarkkinatuki (0/1)
	puoliso: Onko saajalla puolisoa (0/1)
	lapsia: Lapsien lkm perheess 
	huoll: Muiden huollettavien lkm perheess, jos kyseess osittainen tmtuki
	omatulo: Oman muun tulon mr, e/kk
	puoltulo: Puolison tulon mr, e/kk
	vanhtulot: Vanhempien kuukausitulot, jos kyseess osittainen tmtuki, e/kk
	oikeuskor: Onko oikeus korotusosaan (0/1)
	vahsosetuus: Pivrahasta vhennettv muu sosiaalietuus, e/kk
	aktiivi: Aktiivimallin leikkuri;

%MACRO TyomTukiVS(tulos, mvuosi, minf, tarvhark, ositt, puoliso, lapsia, huoll, omatulo, puoltulo, vanhtulot, oikeuskor, vahsosetuus, aktiivi=0)/
DES = 'TTURVA: Tymarkkinatuki kuukausitasolla vuosikeskiarvona';

vuosipraha = 0;

%DO i = 1 %TO 12;
	%TyomTukiKS(temp, &mvuosi, &i, &minf, &tarvhark, &ositt, &puoliso, &lapsia, &huoll, &omatulo, &puoltulo, &vanhtulot, &oikeuskor, &vahsosetuus, aktiivi=&aktiivi);
	vuosipraha = SUM(vuosipraha, temp);
%END;

&tulos = vuosipraha / 12;
DROP vuosipraha temp;
%MEND TyomTukiVS;


/*  6. Makro laskee peruspivrahan kuukausitasolla */

*Makron parametrit: 
	tulos: Makron tulosmuuttuja, peruspivraha, e/kk 
	mvuosi: Vuosi, jonka lainsdnt kytetn
	mkuuk: Kuukausi, jonka lainsdnt kytetn 
	minf: Deflaattori euromristen parametrien kertomiseksi 
    tarvhark: Onko kyseess tarveharkittu Peruspivraha (0/1)
	muutturva: Onko oikeus muutosturvaan (0/1)
	puoliso: Onko saajalla puolisoa (0/1)
	lapsia: Lapsien lkm perheess 
	omatulo: Oman muun tulon mr, e/kk
	puoltulo: Puolison tulon mr, e/kk
	vahsosetuus: Pivrahasta vhennettv muu sosiaalietuus, e/kk
	aktiivi: Aktiivimallin leikkuri;

%MACRO PerusPRahaKS(tulos, mvuosi, mkuuk, minf, tarvhark, muutturva, puoliso, lapsia, omatulo, puoltulo, vahsosetuus, aktiivi=0)/
DES = 'TTURVA: Peruspivraha kuukausitasolla';

%HaeParam&TYYPPI(&mvuosi, &mkuuk, &TTURVA_PARAM, PARAM.&PTTURVA);
%ParamInf&TYYPPI(&mvuosi, &mkuuk, &TTURVA_MUUNNOS, &minf);

*Lapsikorotukset;
IF &lapsia <= 0 THEN lapsikor = 0;
ELSE IF &lapsia < 2 THEN lapsikor = &TTLaps1;
ELSE IF &lapsia < 3 THEN lapsikor = &TTLaps2;
ELSE lapsikor = &TTLaps3;

*Tysmrinen peruspivraha;
temp = &TTPAIVIA * SUM(&TTPerus, lapsikor);
IF &muutturva NE 0 THEN temp = SUM(temp, &TTPAIVIA * &KorotusOsa);

*Tarveharkittu tuki, voimassa ennen vuotta 1994;
IF &tarvhark NE 0 AND &mvuosi < 1994 THEN DO;

	*Perheellisen tarveharkinta;
	IF &puoliso NE 0 OR &lapsia > 0 THEN DO;
		raja = SUM(&RajaHuolt, &lapsia * &RajaLaps );

		IF &puoliso NE 0 THEN DO;
			tulo =  SUM(&puoltulo, -&PuolVah);
			IF tulo < 0 THEN tulo =  0;
		END;

		tulo = SUM(tulo, &omatulo);

		IF tulo > raja THEN temp = SUM(temp, -&TarvPros2 * SUM(tulo, -raja));
	END;

	*Yksinisen tarveharkinta;
	ELSE IF &omatulo > &RajaYks THEN temp = SUM(temp, -&TarvPros1 * SUM(&omatulo -&RajaYks));

	IF temp < 0 THEN temp = 0;
END;

*Aktiivimallin leikkuri;
IF &aktiivi = 1 AND 2018 =< &mvuosi <= 2019 THEN temp = SUM(temp * SUM(1, -&AlePros)); 

temp = temp - &vahsosetuus;
IF temp < 0 THEN temp = 0;

&tulos = temp;
DROP raja temp tulo lapsikor;
%MEND PerusPRahaKS;


/*  7. Makro laskee peruspivrahan kuukausitasolla vuosikeskiarvona */

*Makron parametrit: 
	tulos: Makron tulosmuuttuja, peruspivraha, e/kk (vuosikeskiarvo)
	mvuosi: Vuosi, jonka lainsdnt kytetn
	minf: Deflaattori euromristen parametrien kertomiseksi 
    tarvhark: Onko kyseess tarveharkittu Peruspivraha (0/1)
	muutturva: Onko oikeus muutosturvaan (0/1)
	puoliso: Onko saajalla puolisoa (0/1)
	lapsia: Lapsien lkm perheess 
	omatulo: Oman muun tulon mr, e/kk
	puoltulo: Puolison tulon mr, e/kk
	vahsosetuus: Pivrahasta vhennettv muu sosiaalietuus, e/kk
	aktiivi: Aktiivimallin leikkuri;

%MACRO PerusPRahaVS(tulos, mvuosi, minf, tarvhark, muutturva, puoliso, lapsia, omatulo, puoltulo, vahsosetuus, aktiivi=0)/
DES = 'TTURVA: Peruspivraha kuukausitasolla vuosikeskiarvona';

vuosipraha = 0;

%DO i = 1 %TO 12;
	%PerusPRahaKS(temp, &mvuosi, &i, &minf, &tarvhark, &muutturva, &puoliso, &lapsia, &omatulo, &puoltulo, &vahsosetuus, aktiivi=&aktiivi);
	vuosipraha = SUM(vuosipraha, temp);
%END;

&tulos = vuosipraha / 12;
DROP temp vuosipraha;
%MEND PerusPRahaVS;


/*  8. Makro laskee sovitellun tyttmyysetuuden kuukausitasolla */

*Makron parametrit: 
	tulos: Makron tulosmuuttuja, soviteltu tyttmyysetuus, e/kk 
	mvuosi: Vuosi, jonka lainsdnt kytetn
	mkuuk: Kuukausi, jonka lainsdnt kytetn 
	minf: Deflaattori euromristen parametrien kertomiseksi 
    ansiosid: Onko kyseess ansiosidonnainen tyttmyysetuus (0/1)
	oikeuskor: Onko oikeus korotettuun pivrahaan (0/1)
	lapsia: Lapsien lkm perheess 
	praha: Tyden tuen mr, jos ei olisi soviteltu, e/kk
	tyotulo: Tytulo, joka on sovittelun perusteena, e/kk
	rahapalkka: Ansiosidonnaisen pivrahan perusteena oleva palkka, e/kk
	koultuki: Onko kyseess koulutustuki (0/1)
	vuorsov: Onko kyseess soviteltu vuorottelukorvaus (0/1)
	aktiivi: Aktiivimallin leikkuri
	vahsosetuus: Pivrahasta vhennettv muu sosiaalietuus, e/kk;

%MACRO SoviteltuKS(tulos, mvuosi, mkuuk, minf, ansiosid, oikeuskor, lapsia, praha, tyotulo, rahapalkka, koultuki, vuorsov=0, aktiivi=0, vahsosetuus=0)/
DES = 'TTURVA: Soviteltu tyttmyyspivraha kuukausitasolla';

%HaeParam&TYYPPI(&mvuosi, &mkuuk, &TTURVA_PARAM, PARAM.&PTTURVA);
%ParamInf&TYYPPI(&mvuosi, &mkuuk, &TTURVA_MUUNNOS, &minf);

IF &koultuki NE 0 THEN DO;
	sovsuoja = &SovSuojaKoul;
	sovpros = &SovProsKoul;
END;
ELSE IF &vuorsov NE 0 THEN DO;
	sovsuoja = 0;
	sovpros = &SovPros;
END;
ELSE DO;
	sovsuoja = &SovSuoja;
	sovpros = &SovPros;
END;

*Sovitellun laskukaava. Ei sovitella jos alle suojaosan;
IF &tyotulo < sovsuoja THEN temp2 = &praha;

*Muuten sovitellaan;
ELSE DO; 
	temp2 = &praha - (sovpros * (&tyotulo - sovsuoja));
	IF temp2 < 0 THEN temp2 = 0;
* Jos on ansiosidonnainen pivraha, asetetaan maksimi ja minimi ;
	IF &ansiosid NE 0 THEN DO;
		IF &oikeuskor NE 0 AND &mvuosi > 2002 THEN ylaraja = 1;
		ELSE ylaraja = &SovRaja;

		IF SUM(temp2, &tyotulo) > ylaraja * (1 - &VahPros) * &rahapalkka THEN temp2 = SUM(ylaraja * (1 - &VahPros) * &rahapalkka, -&tyotulo);

		IF &mvuosi >= 1994 THEN DO;
			%PerusPRahaKS(perus, &mvuosi, &mkuuk, &minf, 0, &oikeuskor, 0, &lapsia, 0, 0, 0, aktiivi=&aktiivi);
			temp2 = MAX(temp2, perus - sovpros * (&tyotulo - sovsuoja) * (&tyotulo > sovsuoja));
		END;
	END;
END;

temp2 = temp2 - &vahsosetuus;
IF temp2 < 0 THEN temp2 = 0;

&tulos = temp2;
DROP ylaraja sovsuoja sovpros temp2 perus;
%MEND SoviteltuKS;


/*  9. Makro laskee sovitellun tyttmyysetuuden kuukausitasolla vuosikeskiarvona */

*Makron parametrit: 
	tulos: Makron tulosmuuttuja, soviteltu tyttmyysetuus, e/kk 
	mvuosi: Vuosi, jonka lainsdnt kytetn
	minf: Deflaattori euromristen parametrien kertomiseksi 
    ansiosid: Onko kyseess ansiosidonnainen tyttmyysetuus (0/1)
	oikeuskor: Onko oikeus korotettuun pivrahaan (0/1)
	lapsia: Lapsien lkm perheess 
	praha: Tyden tuen mr, jos ei olisi soviteltu, e/kk
	tyotulo: Tytulo, joka on sovittelun perusteena, e/kk
	rahapalkka: Ansiosidonnaisen pivrahan perusteena oleva palkka, e/kk
	koultuki: Onko kyseess koulutustuki (0/1)
	vuorsov: Onko kyseess soviteltu vuorottelukorvaus (0/1)
	aktiivi: Aktiivimallin leikkuri
	vahsosetuus: Pivrahasta vhennettv muu sosiaalietuus, e/kk;

%MACRO SoviteltuVS(tulos, mvuosi, minf, ansiosid, oikeuskor, lapsia, praha, tyotulo, rahapalkka, koultuki, vuorsov=0, aktiivi=0, vahsosetuus=0)/
DES = 'TTURVA: Soviteltu tyttmyyspivraha kuukausitasolla vuosikeskiarvona';

sovtyot = 0;

%DO i = 1 %TO 12;
	%SoviteltuKS(temp, &mvuosi, &i, &minf, &ansiosid, &oikeuskor, &lapsia, &praha, &tyotulo, &rahapalkka, &koultuki, vuorsov=&vuorsov, aktiivi=&aktiivi, vahsosetuus=&vahsosetuus);
	sovtyot = SUM(sovtyot, temp);
%END;

&tulos = sovtyot / 12;
DROP temp sovtyot;
%MEND SoviteltuVS;


/*  10. Makro laskee ansiosidonnaisen pivrahan perusteena olevan palkan kuukausitasolla (iteroiva knteisfunktio) */

*Makron parametrit: 
	tulos: Makron tulosmuuttuja, ansiosidonnaisen pivrahan perusteena oleva palkka, e/kk 
	mvuosi: Vuosi, jonka lainsdnt kytetn
	mkuuk: Kuukausi, jonka lainsdnt kytetn 
 	lapsia: Lapsien lkm perheess 
	vuosipraha: Saadun ansiosidonnaisen pivrahan mr, e/vuosi
	tayspv: Tyden tuen pivien mr vuoden aikana
	korpv: Korotetun tuen pivien mr vuoden aikana
	mutpv: Muutosturvapivien mr vuoden aikana
	vuor: Jos kyseess on vuorotteluvapaakorvaus (0/1)
	vuorkor: Jos vuorotteluvapaakorvaus on korotettu (0/1)
	sovtayspv: Soviteltujen ei-korotettujen pivien mr
	sovkorpv: Soviteltujen korotettujen pivien mr
	sovtulo: Sovittelun perusteena oleva tytulo (e/kk);

%MACRO AnsioSidPalkkaS(tulos, mvuosi, mkuuk, lapsia, vuosipraha, tayspv, korpv, mutpv, vuor, vuorkor, sovtayspv, sovkorpv, sovmutpv, sovtulo)/
DES = 'TTURVA: Ansiosidonnaisen pivrahan perusteena oleva palkka kuukausitasolla';

%HaeParam&TYYPPI(&mvuosi, &mkuuk, &TTURVA_PARAM, PARAM.&PTTURVA);
%ParamInf&TYYPPI(&mvuosi, &mkuuk, &TTURVA_MUUNNOS, 1); /* INF = 1 */

tayspr = 0; 
korpr = 0; 
mutpr = 0;
vuosipraha = &vuosipraha;

IF &vuor NE 0 THEN DO;	
	IF &vuorkor NE 0 THEN korpros = &VuorKorvPros2;
	ELSE korpros = &VuorKorvPros;
	vuosipraha = &vuosipraha / korpros;
END;

%AnsioSidKS(testi, &mvuosi, &mkuuk, 1, &lapsia, 0, 0, 0, 0, 0, 0, 0, 0);
IF SUM(&tayspv, &korpv, &mutpv, &sovtayspv, &sovkorpv, &sovmutpv) <= 0 THEN &tulos = 0; 
ELSE DO;
	DO i = 0 to 100 UNTIL (apr >= vuosipraha);
		IF MAX(&tayspv, &sovtayspv) > 0 THEN DO;
			%AnsioSidKS(tayspr, &mvuosi, &mkuuk, 1, &lapsia, 0, 0, 0, i * 1000, 0, 0, 0, 0); 
			IF &sovtayspv THEN DO; %SoviteltuKS(sovtayspr, &mvuosi, &mkuuk, 1, 1, 0, &lapsia, tayspr, &sovtulo, i * 1000, 0); END;
			tayspr = SUM(&tayspv * tayspr, &sovtayspv * sovtayspr) / &TTPAIVIA;
		END;
		IF MAX(&korpv, &sovkorpv) > 0 THEN DO;
			%AnsioSidKS(korpr, &mvuosi, &mkuuk, 1, &lapsia, 1, 0, 0, i * 1000, 0, 0, 0, 0);
			IF &sovkorpv THEN DO; %SoviteltuKS(sovkorpr, &mvuosi, &mkuuk, 1, 1, 1, &lapsia, korpr, &sovtulo, i * 1000, 0); END;
			korpr = SUM(&korpv * korpr, &sovkorpv * sovkorpr) / &TTPAIVIA;
		END;
		IF MAX(&mutpv, &sovmutpv) > 0 THEN DO;
			%AnsioSidKS(mutpr, &mvuosi, &mkuuk, 1, &lapsia, 0, 1, 0, i * 1000, 0, 0, 0, 0);
			IF &sovmutpv THEN DO; %SoviteltuKS(sovmutpr, &mvuosi, &mkuuk, 1, 1, 1, &lapsia, mutpr, &sovtulo, i * 1000, 0); END;
			mutpr = SUM(&mutpv * mutpr, &sovmutpv * sovmutpr) / &TTPAIVIA;
		END;
		apr = SUM(tayspr, korpr, mutpr);
	END;

	DO j = -9 to 9 UNTIL (apr >= vuosipraha);
		IF MAX(&tayspv, &sovtayspv) > 0 THEN DO;
			%AnsioSidKS(tayspr, &mvuosi, &mkuuk, 1, &lapsia, 0, 0, 0, (i * 1000 + j * 100), 0, 0, 0, 0); 
			IF &sovtayspv THEN DO; %SoviteltuKS(sovtayspr, &mvuosi, &mkuuk, 1, 1, 0, &lapsia, tayspr, &sovtulo, (i * 1000 + j * 100), 0); END;
			tayspr = SUM(&tayspv * tayspr, &sovtayspv * sovtayspr) / &TTPAIVIA;
		END;
		IF MAX(&korpv, &sovkorpv) > 0 THEN DO;
			%AnsioSidKS(korpr, &mvuosi, &mkuuk, 1, &lapsia, 1, 0, 0, (i * 1000 + j * 100), 0, 0, 0, 0);
			IF &sovkorpv THEN DO; %SoviteltuKS(sovkorpr, &mvuosi, &mkuuk, 1, 1, 1, &lapsia, korpr, &sovtulo, (i * 1000 + j * 100), 0); END;
			korpr = SUM(&korpv * korpr, &sovkorpv * sovkorpr) / &TTPAIVIA;
		END;
		IF MAX(&mutpv, &sovmutpv) > 0 THEN DO;
			%AnsioSidKS(mutpr, &mvuosi, &mkuuk, 1, &lapsia, 0, 1, 0, (i * 1000 + j * 100), 0, 0, 0, 0);
			IF &sovmutpv THEN DO; %SoviteltuKS(sovmutpr, &mvuosi, &mkuuk, 1, 1, 1, &lapsia, mutpr, &sovtulo, (i * 1000 + j * 100), 0); END;
			mutpr = SUM(&mutpv * mutpr, &sovmutpv * sovmutpr) / &TTPAIVIA;
		END;
		apr = SUM(tayspr, korpr, mutpr);
	END;

	DO k = -9 to 9 UNTIL (apr >= vuosipraha);
		IF MAX(&tayspv, &sovtayspv) > 0 THEN DO;
			%AnsioSidKS(tayspr, &mvuosi, &mkuuk, 1, &lapsia, 0, 0, 0, (i * 1000 + j * 100 + k * 10), 0, 0, 0, 0); 
			IF &sovtayspv THEN DO; %SoviteltuKS(sovtayspr, &mvuosi, &mkuuk, 1, 1, 0, &lapsia, tayspr, &sovtulo, (i * 1000 + j * 100 + k * 10), 0); END;
			tayspr = SUM(&tayspv * tayspr, &sovtayspv * sovtayspr) / &TTPAIVIA;
		END;
		IF MAX(&korpv, &sovkorpv) > 0 THEN DO;
			%AnsioSidKS(korpr, &mvuosi, &mkuuk, 1, &lapsia, 1, 0, 0, (i * 1000 + j * 100 + k * 10), 0, 0, 0, 0);
			IF &sovkorpv THEN DO; %SoviteltuKS(sovkorpr, &mvuosi, &mkuuk, 1, 1, 1, &lapsia, korpr, &sovtulo, (i * 1000 + j * 100 + k * 10), 0); END;
			korpr = SUM(&korpv * korpr, &sovkorpv * sovkorpr) / &TTPAIVIA;
		END;
		IF MAX(&mutpv, &sovmutpv) > 0 THEN DO;
			%AnsioSidKS(mutpr, &mvuosi, &mkuuk, 1, &lapsia, 0, 1, 0, (i * 1000 + j * 100 + k * 10), 0, 0, 0, 0);
			IF &sovmutpv THEN DO; %SoviteltuKS(sovmutpr, &mvuosi, &mkuuk, 1, 1, 1, &lapsia, mutpr, &sovtulo, (i * 1000 + j * 100 + k * 10), 0); END;
			mutpr = SUM(&mutpv * mutpr, &sovmutpv * sovmutpr) / &TTPAIVIA;
		END;
		apr = SUM(tayspr, korpr, mutpr);
	END;

	DO m = -9 to 9 UNTIL (apr >= vuosipraha);
		IF MAX(&tayspv, &sovtayspv) > 0 THEN DO;
			%AnsioSidKS(tayspr, &mvuosi, &mkuuk, 1, &lapsia, 0, 0, 0, (i * 1000 + j * 100 + k * 10 + m), 0, 0, 0, 0); 
			IF &sovtayspv THEN DO; %SoviteltuKS(sovtayspr, &mvuosi, &mkuuk, 1, 1, 0, &lapsia, tayspr, &sovtulo, (i * 1000 + j * 100 + k * 10 + m), 0); END;
			tayspr = SUM(&tayspv * tayspr, &sovtayspv * sovtayspr) / &TTPAIVIA;
		END;
		IF MAX(&korpv, &sovkorpv) > 0 THEN DO;
			%AnsioSidKS(korpr, &mvuosi, &mkuuk, 1, &lapsia, 1, 0, 0, (i * 1000 + j * 100 + k * 10 + m), 0, 0, 0, 0);
			IF &sovkorpv THEN DO; %SoviteltuKS(sovkorpr, &mvuosi, &mkuuk, 1, 1, 1, &lapsia, korpr, &sovtulo, (i * 1000 + j * 100 + k * 10 + m), 0); END;
			korpr = SUM(&korpv * korpr, &sovkorpv * sovkorpr) / &TTPAIVIA;
		END;
		IF MAX(&mutpv, &sovmutpv) > 0 THEN DO;
			%AnsioSidKS(mutpr, &mvuosi, &mkuuk, 1, &lapsia, 0, 1, 0, (i * 1000 + j * 100 + k * 10 + m), 0, 0, 0, 0);
			IF &sovmutpv THEN DO; %SoviteltuKS(sovmutpr, &mvuosi, &mkuuk, 1, 1, 1, &lapsia, mutpr, &sovtulo, (i * 1000 + j * 100 + k * 10 + m), 0); END;
			mutpr = SUM(&mutpv * mutpr, &sovmutpv * sovmutpr) / &TTPAIVIA;
		END;
		apr = SUM(tayspr, korpr, mutpr);
	END;

	&tulos = MAX(0, i * 1000 + j * 100 + k * 10 + m);
END;

DROP tayspr korpr mutpr sovtayspr sovkorpr sovmutpr apr i j k m vuosipraha korpros testi lapsikor;
%MEND AnsioSidPalkkaS;


/*  11. Makro laskee ansiosidonnaisen pivrahan perusteena olevan palkan kuukausitasolla (iteroiva knteisfunktio) 
	    (Makroa kytetn aineiston laskennallisten muuttujien pttelyss) */

*Makron parametrit: 
	tulos: Makron tulosmuuttuja, ansiosidonnaisen pivrahan perusteena oleva palkka, e/kk 
	mvuosi: Vuosi, jonka lainsdnt kytetn
	mkuuk: Kuukausi, jonka lainsdnt kytetn 
 	lapsia: Lapsien lkm perheess 
	vuosipraha: Saadun ansiosidonnaisen pivrahan mr, e/vuosi
	tayspv: Tyden tuen pivien mr vuoden aikana
	korpv: Korotetun tuen pivien mr vuoden aikana
	mutpv: Muutosturvapivien mr vuoden aikana
	vuor: Jos kyseess on vuorotteluvapaakorvaus (0/1)
	vuorkor: Jos vuorotteluvapaakorvaus on korotettu (0/1);

%MACRO AnsioSidPalkkaVanhaS(tulos, mvuosi, mkuuk, lapsia, vuosipraha, tayspv, korpv, mutpv, vuor, vuorkor)/
DES = 'TTURVA: Ansiosidonnaisen pivrahan perusteena oleva palkka kuukausitasolla (laskennallisten muuttujien pttelyyn)';

%HaeParam&TYYPPI(&mvuosi, &mkuuk, &TTURVA_PARAM, PARAM.&PTTURVA);
%ParamInf&TYYPPI(&mvuosi, &mkuuk, &TTURVA_MUUNNOS, 1); /* INF = 1 */

tayspr = 0; 
korpr = 0; 
mutpr = 0;
vuosipraha = &vuosipraha;

IF &vuor NE 0 THEN DO;	
	IF &vuorkor NE 0 THEN korpros = &VuorKorvPros2;
	ELSE korpros = &VuorKorvPros;
	vuosipraha = &vuosipraha / korpros;
END;

%AnsioSidKS(testi, &mvuosi, &mkuuk, 1, &lapsia, 0, 0, 0, 0, 0, 0, 0, 0);
IF SUM(&tayspv, &korpv, &mutpv) <= 0 OR (vuosipraha / SUM(&tayspv, &korpv, &mutpv) * &TTPAIVIA <= testi) THEN &tulos = 0;
ELSE DO;
	DO i = 0 to 100 UNTIL (apr >= vuosipraha);
		IF &tayspv > 0 THEN DO;
			%AnsioSidKS(tayspr, &mvuosi, &mkuuk, 1, &lapsia, 0, 0, 0, i * 1000, 0, 0, 0, 0); 
			tayspr = &tayspv * tayspr / &TTPAIVIA;
		END;
		IF &korpv > 0 THEN DO;
			%AnsioSidKS(korpr, &mvuosi, &mkuuk, 1, &lapsia, 1, 0, 0, i * 1000, 0, 0, 0, 0); 
			korpr = &korpv * korpr / &TTPAIVIA;
		END;
		IF &mutpv > 0 THEN DO;
			%AnsioSidKS(mutpr, &mvuosi, &mkuuk, 1, &lapsia, 0, 1, 0, i * 1000, 0, 0, 0, 0);
			mutpr = &mutpv * mutpr / &TTPAIVIA;
		END;
		apr = SUM(tayspr, korpr, mutpr);
	END;

	DO j = -9 to 9 UNTIL (apr >= vuosipraha);
		IF &tayspv > 0 THEN DO;
			%AnsioSidKS(tayspr, &mvuosi, &mkuuk, 1, &lapsia, 0, 0, 0, (i * 1000 + j * 100), 0, 0, 0, 0); 
			tayspr = &tayspv * tayspr / &TTPAIVIA;
		END;
		IF &korpv > 0 THEN DO;
			%AnsioSidKS(korpr, &mvuosi, &mkuuk, 1, &lapsia, 1, 0, 0, (i * 1000 + j * 100), 0, 0, 0, 0); 
			korpr = &korpv * korpr / &TTPAIVIA;
		END;
		IF &mutpv > 0 THEN DO;
			%AnsioSidKS(mutpr, &mvuosi, &mkuuk, 1, &lapsia, 0, 1, 0, (i * 1000 + j * 100), 0, 0, 0, 0);
			mutpr = &mutpv * mutpr / &TTPAIVIA;
		END;
		apr = SUM(tayspr, korpr, mutpr);
	END;

	DO k = -9 to 9 UNTIL (apr >= vuosipraha);
		IF &tayspv > 0 THEN DO;
			%AnsioSidKS(tayspr, &mvuosi, &mkuuk, 1, &lapsia, 0, 0, 0, (i * 1000 + j * 100 + k * 10), 0, 0, 0, 0); 
			tayspr = &tayspv * tayspr / &TTPAIVIA;
		END;
		IF &korpv > 0 THEN DO;
			%AnsioSidKS(korpr, &mvuosi, &mkuuk, 1, &lapsia, 1, 0, 0, (i * 1000 + j * 100 + k * 10), 0, 0, 0, 0); 
			korpr = &korpv * korpr / &TTPAIVIA;
		END;
		IF &mutpv > 0 THEN DO;
			%AnsioSidKS(mutpr, &mvuosi, &mkuuk, 1, &lapsia, 0, 1, 0, (i * 1000 + j * 100 + k * 10), 0, 0, 0, 0);
			mutpr = &mutpv * mutpr / &TTPAIVIA;
		END;
		apr = SUM(tayspr, korpr, mutpr);
	END;

	DO m = -9 to 9 UNTIL (apr >= vuosipraha);
		IF &tayspv > 0 THEN DO;
			%AnsioSidKS(tayspr, &mvuosi, &mkuuk, 1, &lapsia, 0, 0, 0, (i * 1000 + j * 100 + k * 10 + m), 0, 0, 0, 0); 
			tayspr = &tayspv * tayspr / &TTPAIVIA;
		END;
		IF &korpv > 0 THEN DO;
			%AnsioSidKS(korpr, &mvuosi, &mkuuk, 1, &lapsia, 1, 0, 0, (i * 1000 + j * 100 + k * 10 + m), 0, 0, 0, 0); 
			korpr = &korpv * korpr / &TTPAIVIA;
		END;
		IF &mutpv > 0 THEN DO;
			%AnsioSidKS(mutpr, &mvuosi, &mkuuk, 1, &lapsia, 0, 1, 0, (i * 1000 + j * 100 + k * 10 + m), 0, 0, 0, 0);
			mutpr = &mutpv * mutpr / &TTPAIVIA;
		END;
		apr = SUM(tayspr, korpr, mutpr);
	END;

	&tulos = (i * 1000 + j * 100 + k * 10 + m);
END;

DROP tayspr korpr mutpr apr i j k m vuosipraha korpros testi lapsikor;
%MEND AnsioSidPalkkaVanhaS;


/*  12. Makro laskee yllpitokorvaukset kuukausitasolla */

*Makron parametrit: 
	tulos: Makron tulosmuuttuja, yllpitokorvaukset, e/kk 
	mvuosi: Vuosi, jonka lainsdnt kytetn
	mkuuk: Kuukausi, jonka lainsdnt kytetn 
	minf: Deflaattori euromristen parametrien kertomiseksi 
	oikeuskor: Onko oikeus korotettuun yllpitokorvaukseen (0/1);

%MACRO YPitoKorvS(tulos, mvuosi, mkuuk, minf, oikeuskor)/
DES = 'TTURVA: Yllpitokorvaukset kuukausitasolla';

%HaeParam&TYYPPI(&mvuosi, &mkuuk, &TTURVA_PARAM, PARAM.&PTTURVA);
%ParamInf&TYYPPI(&mvuosi, &mkuuk, &TTURVA_MUUNNOS, &minf);

&tulos = &TTPAIVIA * &YPiToK * ((&oikeuskor NE 0) + 1);

%MEND YPitoKorvS;


/*  13. Makro laskee yllpitokorvaukset kuukausitasolla vuosikeskiarvona */

*Makron parametrit: 
	tulos: Makron tulosmuuttuja, yllpitokorvaukset, e/kk 
	mvuosi: Vuosi, jonka lainsdnt kytetn
	minf: Deflaattori euromristen parametrien kertomiseksi 
	oikeuskor: Onko oikeus korotettuun yllpitokorvaukseen (0/1);

%MACRO YPitoKorvVS(tulos, mvuosi, minf, oikeuskor)/
DES = 'TTURVA: Yllpitokorvaukset kuukausitasolla vuosikeskiarvona';

ypito = 0;

%DO i = 1 %TO 12;
	%YPitoKorvS(temp, &mvuosi, &i, &minf, &oikeuskor);
	ypito = SUM(ypito, temp);
%END;

&tulos = ypito / 12;
DROP temp ypito;
%MEND YPitoKorvVS;


/*  14. Makro laskee vuorotteluvapaakorvaukset kuukausitasolla */

*Makron parametrit: 
	tulos: Makron tulosmuuttuja, vuorotteluvapaakorvaukset, e/kk 
	mvuosi: Vuosi, jonka lainsdnt kytetn
	mkuuk: Kuukausi, jonka lainsdnt kytetn 
	minf: Deflaattori euromristen parametrien kertomiseksi 
	perust: Onko perusturvan vuorotteluvapaakorvaus (0/1)
	korotus: Onko kyseess korotettu korvaus (0/1)
	palkka: Korvauksen perusteena oleva palkka, e/kk
	spalkka: Sovitellun vuorotteluvapaakorvauksen perusteena oleva palkka, e/kk
	vahsosetuus: Pivrahasta vhennettv muu sosiaalietuus, e/kk;

%MACRO VuorVapKorvKS(tulos, mvuosi, mkuuk, minf, perust, korotus, palkka, spalkka=0, vahsosetuus=0)/
DES = 'TTURVA: Vuorotteluvapaakorvaukset kuukausitasolla';

%HaeParam&TYYPPI(&mvuosi, &mkuuk, &TTURVA_PARAM, PARAM.&PTTURVA);
%ParamInf&TYYPPI(&mvuosi, &mkuuk, &TTURVA_MUUNNOS, &minf);

IF &perust NE 0 THEN DO;
	%PerusPRahaKS(temp1, &mvuosi, &mkuuk, &minf, 0, 0, 0, 0, 0, 0, 0);
END;

ELSE DO;
	%AnsioSidKS(temp1, &mvuosi, &mkuuk, &minf, 0, 0, 0, 0, &palkka, 0, 0, 0);
END;

*Lasketaan soviteltu pivraha, jos aineistossa sovittelun perusteena oleva palkka;
IF &spalkka > 0 THEN DO;
	%SoviteltuKS(temp, &mvuosi, 1, &INF, (&perust=0), 0, 0, temp1, &spalkka, &palkka, 0, vuorsov=1);
END;

ELSE DO;
	temp = temp1;
END;

temp = temp -&vahsosetuus;
IF temp < 0 THEN temp = 0;

*Vuorottelukorvaus on tietty osuus siit tyttmyysetuudesta, johon olisi oikeutettu tyttmn;
temp = temp * ((&korotus NE 0) * &VuorKorvPros2 + (&korotus = 0) * &VuorKorvPros);

IF &mvuosi IN (1996,1997) AND temp > &VuorKorvYlaRaja THEN temp = &VuorKorvYlaRaja;


&tulos = temp;
DROP temp temp1;
%MEND VuorVapKorvKS;


/*  15. Makro laskee vuorotteluvapaakorvaukset kuukausitasolla vuosikeskiarvona */

*Makron parametrit: 
	tulos: Makron tulosmuuttuja, vuorotteluvapaakorvaukset, e/kk 
	mvuosi: Vuosi, jonka lainsdnt kytetn
	minf: Deflaattori euromristen parametrien kertomiseksi 
	perust: Onko perusturvan vuorotteluvapaakorvaus (0/1)
	korotus: Onko kyseess korotettu korvaus (0/1)
	palkka: Korvauksen perusteena oleva palkka, e/kk
	spalkka: Sovitellun vuorotteluvapaakorvauksen perusteena oleva palkka, e/kk
	vahsosetuus: Pivrahasta vhennettv muu sosiaalietuus, e/kk;

%MACRO VuorVapKorvVS(tulos, mvuosi, minf, perust, korotus, palkka, spalkka=0, vahsosetuus=0)/
DES = 'TTURVA: Vuorotteluvapaakorvaukset kuukausitasolla vuosikeskiarvona';

vuorvapkorv = 0;

%DO i = 1 %TO 12;
	%VuorVapKorvKS(temp, &mvuosi, &i, &minf, &perust, &korotus, &palkka, spalkka=&spalkka, vahsosetuus=&vahsosetuus);
	vuorvapkorv = SUM(vuorvapkorv, temp);
%END;

&tulos = vuorvapkorv / 12;
DROP temp vuorvapkorv;
%MEND VuorVapKorvVS;


/*  16. Makro laskee sovittelun pivrahan perusteena olevan tulon kuukausitasolla (knteisfunktio) */

*Makron parametrit: 
	tulos: Makron tulosmuuttuja, sovittelun pivrahan perusteena oleva tulo, e/kk 
	mvuosi: Vuosi, jonka lainsdnt kytetn
	mkuuk: Kuukausi, jonka lainsdnt kytetn 
	koul: Onko kyseess koulutustuki (0/1)
	sovpraha: Sovitellun pivrahan mr (e/kk)
	praha: Tyden tuen mr, jos ei olisi soviteltu, e/kk
	lapsia: Lapsien lkm perheess
	rahapalkka: Tyttmyytt edeltv kuukausipalkka ansioturvassa, e/kk
	oikeuskor: Onko oikeus korotettuun pivrahaan (sis. muutosturvalis);

%MACRO SovPalkkaS(tulos, mvuosi, mkuuk, koul, sovpraha, praha, lapsia, rahapalkka, oikeuskor)/
DES = 'TTURVA: Sovitellun pivrahan perusteena oleva palkka kuukausitasolla';

%HaeParam&TYYPPI(&mvuosi, &mkuuk, &TTURVA_PARAM, PARAM.&PTTURVA);
%ParamInf&TYYPPI(&mvuosi, &mkuuk, &TTURVA_MUUNNOS, 1); /* INF = 1 */

IF &koul NE 0 THEN DO;
	sovsuoja = &SovSuojaKoul;
	sovpros = &SovProsKoul;
END;

ELSE DO;
	sovsuoja = &SovSuoja;
	sovpros = &SovPros;
END;

* Laskentakaava normaalitilanteessa;
IF sovpros NE 0 THEN temp3 = (&praha - &sovpraha + (sovpros * sovsuoja)) / sovpros;

IF &rahapalkka NE 0 THEN DO;
	IF &oikeuskor NE 0 AND &mvuosi > 2002 THEN ylaraja = 1;
	ELSE ylaraja = &SovRaja;

	* Jos normaalitilanteen mukaan ptellyll sovittelupalkalla laskettu soviteltu pivraha alittaa todellisen sovitellun pivrahan,
	ollaan todennkisesti ylrajalla. Tllin sovittelupalkka ja soviteltu pivraha ovat yhteens yht suuret kuin etuuden perusteena
	oleva palkka (kerrottuna ylrajaparametrilla);
	%SoviteltuKS(test, &mvuosi, &mkuuk, 1, 1, &oikeuskor, &lapsia, &praha, temp3, &rahapalkka, &koul);
	IF ROUND(SUM(test, -&sovpraha), 0.01) < 0 THEN DO;
		temp3 = SUM(ylaraja * (1 - &VahPros) * &rahapalkka, - &sovpraha);

		* Jos thn asti ptellyll sovittelupalkalla laskettu soviteltu pivraha ylitt todellisen sovitellun pivrahan,
		ollaan todennkisesti tilanteessa, jossa henkil saa ansiopivrahaa peruspivrahan suuruisena. Tllin lasketaan sovittelupalkka
		normaalikaavalla peruspivrahan mrn perusteella;
		%SoviteltuKS(test2, &mvuosi, &mkuuk, 1, 1, &oikeuskor, &lapsia, &praha, temp3, &rahapalkka, &koul);
		IF ROUND(SUM(test2, -&sovpraha), 0.01) > 0 THEN DO;
			%PerusPRahaKS(perus, &mvuosi, &mkuuk, 1, 0, &oikeuskor, 0, &lapsia, 0, 0, 0);
			 IF sovpros NE 0 THEN temp3 = SUM(perus, -&sovpraha, sovpros * sovsuoja) / sovpros;
		END;
	END;
END;

IF temp < 0 THEN temp3 = 0;
IF &sovpraha >= &praha THEN temp3 = 0;
IF &mvuosi < 1997 then temp3=.;

&tulos = temp3;
DROP sovsuoja sovpros temp3 ylaraja test test2;
%MEND SovPalkkaS;


/*  17. Makro laskee tarveharkinnan perusteena olevan tulon kuukausitasolla (knteisfunktio) */

*Makron parametrit: 
	tulos: Makron tulosmuuttuja, tarveharkinnan perusteena oleva tulo, e/kk 
	mvuosi: Vuosi, jonka lainsdnt kytetn
	mkuuk: Kuukausi, jonka lainsdnt kytetn 
	puoliso: Onko saajalla puolisoa (0/1)
	lapsia: Lapsien lkm perheess 
	oikeuskor: Onko oikeus korotusosaan (0/1)
	tmtuki: Tarveharkitun tymarkkinatuen mr, e/kk;

%MACRO TarvHarkTuloS(tulos, mvuosi, mkuuk, puoliso, lapsia, oikeuskor, tmtuki)/
DES = 'TTURVA: Tymarkkinatuen tarveharkinnan perusteena oleva tulo kuukausitasolla';

%HaeParam&TYYPPI(&mvuosi, &mkuuk, &TTURVA_PARAM, PARAM.&PTTURVA);
%ParamInf&TYYPPI(&mvuosi, &mkuuk, &TTURVA_MUUNNOS, 1); /* INF = 1 */

%TyomTukiKS(taysi, &mvuosi, &mkuuk, 1, 0, 0, 0, &lapsia, 0, 0, 0, 0, &oikeuskor, 0);

IF &puoliso NE 0 OR &lapsia > 0 THEN DO;
	vah= &RajaHuolt + &lapsia * &RajaLaps;
	tarvpros = &TarvPros2;
END;

ELSE DO; 
	vah = &RajaYks;
	tarvpros = &TarvPros1;
END;

IF &puoliso NE 0 THEN vah = vah + &PuolVah;
IF tarvpros > 0 THEN temp = (taysi - &tmtuki + (tarvpros * vah)) / tarvpros;

IF &tmtuki >= taysi OR temp < 0 THEN temp = 0;

&tulos = temp;
DROP taysi tarvpros vah temp;
%MEND TarvHarkTuloS;


/*  18. Makro laskee osittaisen tymarkkinatuen perusteena olevan vanhempien tulon kuukausitasolla (knteisfunktio) */

*Makron parametrit: 
	tulos: Makron tulosmuuttuja, tymarkkinatuen perusteena oleva vanhempien tulo, e/kk 
	mvuosi: Vuosi, jonka lainsdnt kytetn
	mkuuk: Kuukausi, jonka lainsdnt kytetn 
	minf: Deflaattori euromristen parametrien kertomiseksi 
    huoll: Muiden huollettavien lkm perheess
	oikeuskor: Onko oikeus korotusosaan (0/1)
	tmtuki: Osittaisen tymarkkinatuen mr, e/kk;

%MACRO OsittTmTTuloS(tulos, mvuosi, mkuuk, huoll, oikeuskor, tmtuki)/
DES = 'TTURVA: Osittaisen tymarkkinatuen perusteena oleva vanhempien tulo kuukausitasolla';

%HaeParam&TYYPPI(&mvuosi, &mkuuk, &TTURVA_PARAM, PARAM.&PTTURVA);
%ParamInf&TYYPPI(&mvuosi, &mkuuk, &TTURVA_MUUNNOS, 1); /* INF = 1 */

%TyomTukiKS(taysi, &mvuosi, &mkuuk, 1, 0, 0, 0, 0, 0, 0, 0, 0, &oikeuskor, 0);

raja = (&OsRaja + (&huoll * &OsRajaKor));
temp = SUM((&OsTarvPros * raja), taysi, -&tmtuki) / &OsTarvPros;

IF &tmtuki >= &OsPros * taysi AND &tmtuki < taysi THEN &tulos = temp;
ELSE IF &tmtuki < &OsPros * taysi THEN &tulos = 99999999;
ELSE &tulos = 0;

DROP raja taysi temp;
%MEND OsittTmTTuloS;

/*  19. Ansiopivrahan ja vuorottelukorvauksen enimmis- ja vhimmiskeston rajaus  */

*Makron parametrit: 
	tulos: Makron tulosmuuttuja, siirtyvt pivt ("netto") (neg. arvo tarkoittaa listyt pivt)
	mvuosi: Vuosi, jonka lainsdnt kytetn
	mkuuk: Kuukausi, jonka lainsdnt kytetn 
	kertymapv: Ansiopivrahan kertym ns. nettona eli sovitellut pivt kokonaisina
	tyohistv: Henkiln tyhistoria vuosina
	lasktyohistv: Henkiln laskennallinen tyhistoria vuosina lispivoikeutta varten (vuositulojen jako 510:ll)
	taytkk: kuukausi jolloin kertym on tullut tyteen (1-12, . jos ei ole tyttynyt, 99 jos tyttynyt aineistossa muttei simuloidussa lainsdnnss, -99 jos lispivoikeus jo ed. vuonna)
	ikavu: ik vuosina vuoden lopussa
	ikakk: ikvuoden ylttvt kuukaudet vuoden lopussa (0-11)
	tmtukipv: tymarkkinatukipivt nettona eli sovitellut pivt kokonaisina
	tyooloehto: tyttk tyoloehdon (0/1)
	vuorkorv: onko kyseess vuorottelukorvauksen rajaus (0/1)
;

%MACRO AnsioSidKestoRaj(tulos, mvuosi, mkuuk, kertymapv, tyohistv, lasktyohistv, taytkk, ikavu, ikakk, tmtukipv, tyooloehto, vuorkorv)/
DES = 'TTURVA: Ansiopivrahan ja vuorottelukorvauksen enimmis- ja vhimmiskeston rajaus';

%HaeParam&TYYPPI(&mvuosi, &mkuuk, &TTURVA_PARAM, PARAM.&PTTURVA);
%ParamInf&TYYPPI(&mvuosi, &mkuuk, &TTURVA_MUUNNOS, 1);


*Ansiopivrahan rajoitus;
IF NOT &vuorkorv THEN DO;

	IF &mvuosi >= 2017 AND &lasktyohistv >= &LisaPvTyoHist AND &tyooloehto = 1 AND (&ikavu > &KestoIkaRaja OR (&ikavu = &KestoIkaRaja AND &taytkk > 12 - ikakk)) THEN ENIMMAISKESTO = &AnsioSidKesto3;
	ELSE IF &mvuosi >= 2014 AND &tyohistv <= &KestoLyhEhtoV THEN ENIMMAISKESTO = &AnsioSidKesto2;
	ELSE ENIMMAISKESTO = &AnsioSidKesto;

	*Ansiopivrahoja lis, jos henkil tytt vaaditun tyohistoriaehdon ja lispivin ennen kuin enimmisaika tyttynyt tarkasteluvuonna;
	IF &taytkk > 0 AND &lasktyohistv >= &LisaPvTyohist AND (&LisaPvAlaIka < &ikavu < &LisaPvYlaika OR (&ikavu = &LisaPvAlaIka AND (&mvuosi IN (2007,2008,2014,2017,2022,2025,2027) OR (12 - &ikakk) <= &taytkk))) THEN temp = MIN(-&tmtukipv, 0);
	ELSE IF &taytkk > 0 AND &lasktyohistv >= &LisaPvTyohist AND &ikavu = &LisaPvYlaika THEN temp = MIN(12 - &ikakk, (&tmtukipv / &TTPaivia)) * -&TTPaivia;

	*Ansiopivrahoja lis, jos enimmiskesto ei ole tyttynyt, mutta datassa kuitenkin on;
	ELSE IF &taytkk NE . AND &tmtukipv > 0 AND ENIMMAISKESTO > &kertymapv THEN temp = MAX(-&tmtukipv, SUM(&kertymapv, -ENIMMAISKESTO));

	*Ansiopivrahoja pois, jos enimmiskesto on tyttynyt. Vaikka olisi tyttynyt edellisvuonna, kunhan ei lispivoikeutta;
	ELSE IF &taytkk NE -99 AND ENIMMAISKESTO < &kertymapv THEN temp = MAX(0, SUM(&kertymapv, -ENIMMAISKESTO));

	ELSE temp=0;
END;

*Vuorottelukorvauksen rajoitus. Sovittelu ei vaikuta vuorottelukorvauksen kestoon. ;
ELSE DO;

	*Datan pivt tytyy muuttaa arkipivist kalenteripiviksi lain mukaisesti;
	KALENTERIPV = &kertymapv * (7/5);

	*Otetaan pivn liikkumavara, koska tyttmyyspivien tai arkipivien vuosimr voi vaihdella;
	IF FLOOR(KALENTERIPV)- 1 > &VuorKorvMaxKesto THEN temp = ROUND((5/7) * SUM(KALENTERIPV, -&VuorKorvMaxKesto));

	*Minimivaatimusta ei sovelleta toistaiseksi, koska ei pystyt erottaa kuluvaa jaksoa pttyneest;
	*ELSE IF ROUND(KALENTERIPV) < &VuorKorvMinKesto THEN temp = ROUND((5/7) * SUM(KALENTERIPV, -&VuorKorvMinKesto));
	ELSE temp = 0;
END;

&tulos = temp;

DROP ENIMMAISKESTO KALENTERIPV;
%MEND;

