/*********************************************
* Kuvaus: Makroja rahamrien pyristmiseen *
* Viimeksi paivitetty: 24.1.2018             *
*********************************************/

/* Tiedosto sislt seuraavat makrot:
1. PyoristysSentinTarkkuuteen = Pyrist annetun rahamrn sentin tarkkuuteen
2. PyoristysEuronTarkkuuteen = Pyrist annetun rahamrn euron tarkkuuteen
3. Pyoristys100mk = Pyrist annetun rahamrn 100 markan tarkkuuteen
4. Pyoristys1000mk = Pyrist annetun rahamrn 1000 markan tarkkuuteen
5. Pyoristys10e = Pyrist annetun rahamrn 10 euron tarkkuuteen
6. Pyoristys100e = Pyrist annetun rahamrn 100 euron tarkkuuteen
*/

/* 1. Pyrist annetun rahamrn sentin tarkkuuteen */

/* Makron parametrit:
		tulos: Makron tulosmuuttuja, sentin tarkkuuteen pyristetty rahamr
		rahamaara: Rahamaara, joka halutaan pyrist */

%MACRO PyoristysSentinTarkkuuteen(tulos, rahamaara)/
DES = "PyoristysMakrot: Pyrist annetun rahamrn sentin tarkkuuteen";

	&tulos = ROUND(&rahamaara, 0.01); 	

%MEND PyoristysSentinTarkkuuteen;


/* 2. Pyrist annetun rahamrn euron tarkkuuteen */

/* Makron parametrit:
		tulos: Makron tulosmuuttuja, euron tarkkuuteen pyristetty rahamr
		rahamaara: Rahamaara, joka halutaan pyrist */

%MACRO PyoristysEuronTarkkuuteen(tulos, rahamaara)/
DES = "PyoristysMakrot: Pyrist annetun rahamrn euron tarkkuuteen";

	&tulos = ROUND(&rahamaara, 1);

%MEND PyoristysEuronTarkkuuteen;


/* 3. Pyrist annetun rahamrn 100 markan tarkkuuteen */

/* Makron parametrit:
		tulos: Makron tulosmuuttuja, euron tarkkuuteen pyristetty rahamr
		arvo: Rahamaara, joka halutaan pyrist */

%MACRO Pyoristys100mk (tulos, arvo)/
DES = 'PyoristysMakrot: Pyristys 100 markan tarkkuuteen';
&tulos = &euro * &arvo / 100;
&tulos = CEIL(&tulos);
&tulos = 100 * &tulos;
&tulos = &tulos / &euro;
%MEND Pyoristys100mk;


/* 4. Pyrist annetun rahamrn 1000 markan tarkkuuteen */

/* Makron parametrit:
		tulos: Makron tulosmuuttuja, euron tarkkuuteen pyristetty rahamr
		arvo: Rahamaara, joka halutaan pyrist */

%MACRO Pyoristys1000mk (tulos, arvo)/
DES = 'PyoristysMakrot: Pyristys 1000 markan tarkkuuteen';
&tulos = &euro * &arvo / 1000;
&tulos = CEIL(&tulos);
&tulos = 1000 * &tulos;
&tulos = &tulos / &euro;
%MEND Pyoristys1000mk;


/* 5. Pyrist annetun rahamrn 10 euron tarkkuuteen */

/* Makron parametrit:
		tulos: Makron tulosmuuttuja, euron tarkkuuteen pyristetty rahamr
		arvo: Rahamaara, joka halutaan pyrist */

%MACRO Pyoristys10e(tulos, arvo)/
DES = 'PyoristysMakrot: Pyristys 10 euron tarkkuuteen';
&tulos = CEIL(&arvo / 10);
&tulos = 10 * (&tulos);
%MEND Pyoristys10e;


/* 6. Pyrist annetun rahamrn 100 euron tarkkuuteen */

/* Makron parametrit:
		tulos: Makron tulosmuuttuja, euron tarkkuuteen pyristetty rahamr
		arvo: Rahamaara, joka halutaan pyrist */

%MACRO Pyoristys100e(tulos, arvo)/
DES = 'PyoristysMakrot: Pyristys 100 euron tarkkuuteen';
&tulos = CEIL(&arvo / 100);
&tulos = 100 * &tulos;
%MEND Pyoristys100e;